# -*- coding: utf-8 -*-
#
# ライフゲーム・シミュレータ
# 2011.6.27

import tkinter as Tk
#import tkFileDialog #python2
from tkinter import filedialog as tkFileDialog #python3
from random import *

########## パラメータ設定 ##########

WIDTH  = 30  # 横向きの格子数（10以上）
HEIGHT = 23 # 縦向きの格子数（10以上）

RATE   = 10  # ランダムな初期化におけるセルの発生確率
TIMING = 100 # アニメーションのタイミング（ミリ秒）
BGCOLOR   = 'ivory'   # 背景色
CELLCOLOR = 'gold'  # セルの描画色

'''
使える色のいろいろ
white, gray, darkgrey, black, gray0, gray1, ..., gray100
red, tomato, orangered, orange, darkorange
yellow, lightyellow, brown, maroon, salmon
blue, skyblue, navy, cyan, green, darkgreen,
purple, violet, plum, magenta
'''

########## 大域変数 ##########

FWIDTH_MAX  = 1000  # 画面の最大幅
FHEIGHT_MAX = 800   # 画面の最大高
FWIDTH  = 0         # フレームの幅　　（あとで計算）
FHEIGHT = 0         # フレームの高さ　（あとで計算）
DIAMETER = 0        # セルの直径　　　（あとで計算）
CWIDTH  = 0         # キャンバスの幅　（あとで計算）
CHEIGHT = 0         # キャンバスの高さ（あとで計算）
a = []              # セルを格納する配列
a0 = []             # セルの初期状態を格納する配列
gen = 0             # 世代
items = []          # 描画アイテム

########## メイン・フレーム ##########

class Frame(Tk.Frame):

    def __init__(self, master = None):
        global a
        global gen
        global TIMING

        self.set_parameters()
      
        Tk.Frame.__init__(self, master, width = FWIDTH, height = FHEIGHT)
        self.master.title('ライフゲーム・シミュレータ')  # タイトル
        self.master.geometry('+10+10')  # 画面左上からの相対位置

        self.cvs = Tk.Canvas(self, width = CWIDTH, height = CHEIGHT, background = BGCOLOR, borderwidth = 0)
        self.cvs.place(x = 150, y = 1)
        
        self.b1 = Tk.Button(self, text = 'ランダムな初期化', command = self.random_initialize)
        self.b1.place(x = 10, y = 5, width = 130)
        self.b2 = Tk.Button(self, text = 'グライダー', command = glider)
        self.b2.place(x = 10, y = 30, width = 130)
        self.b3 = Tk.Button(self, text = '２個のグライダー', command = two_gliders)
        self.b3.place(x = 10, y = 55, width = 130)
        self.b4 = Tk.Button(self, text = '宇宙船', command = spaceship)
        self.b4.place(x = 10, y = 80, width = 130)
        self.b5 = Tk.Button(self, text = 'どんぐり', command = acorn)
        self.b5.place(x = 10, y = 105, width = 130)
        self.b6 = Tk.Button(self, text = 'ダイ・ハード', command = die_hard)
        self.b6.place(x = 10, y = 130, width = 130)
        self.b7 = Tk.Button(self, text = '初期データ保存', command = self.save)
        self.b7.place(x = 10, y = 155, width = 130)
        self.b8 = Tk.Button(self, text = 'データ読み出し', command = self.load)
        self.b8.place(x = 10, y = 180, width = 130)

        self.label1 = Tk.Label(self, text = '最大ウィンドウサイズ : ')
        self.label1.place(x = 10, y = 215, width = 130)
        self.iv1 = Tk.IntVar()
        self.iv1.set(FWIDTH_MAX)
        self.entry1 = Tk.Entry(self, textvariable = self.iv1)
        self.entry1.place(x = 20, y = 240, width = 40)
        self.entry1.bind('<Return>', self.change_size1)
        self.label2 = Tk.Label(self, text = ' × ')
        self.label2.place(x = 70, y = 240, width = 10)
        self.iv2 = Tk.IntVar()
        self.iv2.set(FHEIGHT_MAX)
        self.entry2 = Tk.Entry(self, textvariable = self.iv2)
        self.entry2.place(x = 90, y = 240, width = 40)
        self.entry2.bind('<Return>', self.change_size1)

        self.label3 = Tk.Label(self, text = 'フィールドサイズ : ')
        self.label3.place(x = 10, y = 270, width = 130)
        self.iv3 = Tk.IntVar()
        self.iv3.set(WIDTH)
        self.entry3 = Tk.Entry(self, textvariable = self.iv3)
        self.entry3.place(x = 20, y = 295, width = 40)
        self.entry3.bind('<Return>', self.change_size2)
        self.label4 = Tk.Label(self, text = ' × ')
        self.label4.place(x = 70, y = 295, width = 10)
        self.iv4 = Tk.IntVar()
        self.iv4.set(HEIGHT)
        self.entry4 = Tk.Entry(self, textvariable = self.iv4)
        self.entry4.place(x = 90, y = 295, width = 40)
        self.entry4.bind('<Return>', self.change_size2)

        self.sv5 = Tk.StringVar()
        self.label5 = Tk.Label(self, textvariable = self.sv5, font = '14', anchor = Tk.W)
        self.label5.place(x = 10, y = 335, width = 130)
        self.sv6 = Tk.StringVar()
        self.label6 = Tk.Label(self, textvariable = self.sv6, font = '14', anchor = Tk.W)
        self.label6.place(x = 10, y = 360, width = 130)

        self.random_initialize()
        self.draw()

    ########## 描画 ##########
 
    def draw(self):
        global a
        global gen
        global TIMING
        global items
        global CWIDTH
        global CHEIGHT

        self.cvs.config(width = CWIDTH, height = CHEIGHT)
        
        # キャンバスのアイテム・セル数の初期化     
        for p in items:
            self.cvs.delete(p)
        count = 0
        items = []

        # セルの描画
        for i in range(0, WIDTH):
            x = DIAMETER * i + 3
            for j in range(0, HEIGHT):
                y = DIAMETER * j + 3
                if a[i][j]:
                    count += 1
                    p = self.cvs.create_oval(x, y, x + DIAMETER, y + DIAMETER, fill = CELLCOLOR, width = 1, outline = 'black')
                    items.append(p)
                    
        # データの表示 
        self.sv5.set('第 %d 世代' % gen)
        self.sv6.set('セル数 : %d' % count)

        # 次世代の計算と描画
        self.next_generation()
        gen += 1            
        if gen == 1:
            self.cvs.after(1200, self.draw)
        else:
            self.cvs.after(TIMING, self.draw)

    ########## 次世代の計算 ##########

    def next_generation(self):
        global a
        global gen
        global TIMING

        # ムーア近傍の計算
        nbd = []
        for i in range(0, WIDTH):
            im = (i - 1) % WIDTH
            ip = (i + 1) % WIDTH
            y = []
            for j in range(0, HEIGHT):
                jm = (j - 1) % HEIGHT
                jp = (j + 1) % HEIGHT
                x = a[im][jm] + a[im][j] + a[im][jp] + a[i][jm] + a[i][jp] + a[ip][jm] + a[ip][j] + a[ip][jp]
                y.append(x)
            nbd.append(y)

        # ルール適用 
        for i in range(0, WIDTH):
            for j in range(0, HEIGHT):
                x = nbd[i][j]   # 周囲８セルのうち埋まっているセルの個数
                # セルが埋まっている場合、近傍セル数が 2, 3 以外では消滅
                if a[i][j]:
                    if x < 2 or x > 3:
                        a[i][j] = 0
                # セルが空の場合、近傍セル数が 3 のときのみ誕生
                else:
                    if x == 3:
                        a[i][j] = 1

    ########## ランダムな初期化 ##########

    def random_initialize(self):
        global a
        global gen
        a = []
        gen = 0
        for i in range(0, WIDTH):
            b = []
            for j in range(0, HEIGHT):
                if randint(0, 99) < RATE:
                    b.append(1)
                else:
                    b.append(0)
            a.append(b)
        initial_data_copy()

    ########## パラメータ設定 ##########

    def set_parameters(self):
        global FWIDTH_MAX
        global FHEIGHT_MAX
        global FWIDTH
        global FHEIGHT
        global CWIDTH
        global CHEIGHT
        global DIAMETER
        global WIDTH
        global HEIGHT
        
        d1 = (FWIDTH_MAX - 166) // WIDTH
        d2 = (FHEIGHT_MAX -20) // HEIGHT
        if d1 < d2:
            DIAMETER = d1
        else:
            DIAMETER = d2
        CWIDTH  = DIAMETER * WIDTH  + 4
        CHEIGHT = DIAMETER * HEIGHT + 4
        FWIDTH = CWIDTH + 166
        FHEIGHT = CHEIGHT + 5
        if FHEIGHT < 400:
            FHEIGHT = 400
            self.iv2.set(FHEIGHT_MAX)

    ########## フレームサイズ変更１ ##########

    def change_size1(self, event):
        global FWIDTH_MAX
        global FHEIGHT_MAX

        FWIDTH_MAX  = self.iv1.get()
        FHEIGHT_MAX = self.iv2.get()
        self.set_parameters()
        self.config(width = FWIDTH, height = FHEIGHT)
        self.cvs.config(width = CWIDTH, height = CHEIGHT)

    ########## フレームサイズ変更２ ##########

    def change_size2(self, event):
        global WIDTH
        global HEIGHT

        WIDTH  = self.iv3.get()
        HEIGHT = self.iv4.get()
        self.set_parameters()
        self.config(width = FWIDTH, height = FHEIGHT)
        self.cvs.config(width = CWIDTH, height = CHEIGHT)
        self.random_initialize()


    ########## 初期データの保存 ##########
        
    def save(self):
        dname = tkFileDialog.asksaveasfilename(filetypes = [('', '*.txt')], initialdir = './')
        dfile = open(dname, 'w')
        dfile.write('%d\n' % WIDTH)
        dfile.write('%d\n' % HEIGHT)
        for x in a0:
            for y in x:
                dfile.write('%d\n' % y)
        dfile.close()

    ########## データ読み出し ##########
    
    def load(self):
        global a
        global gen
        global WIDTH
        global HEIGHT
        global CWIDTH
        global CHEIGHT

        dname = tkFileDialog.askopenfilename(filetypes = [('', '*.txt')], initialdir = './')
        dfile = open(dname, 'r')
        WIDTH  = int(dfile.readline())
        HEIGHT = int(dfile.readline())
        self.set_parameters()
        self.config(width = FWIDTH, height = FHEIGHT)
        self.cvs.config(width = CWIDTH, height = CHEIGHT)
        
        self.iv3.set(WIDTH)
        self.iv4.set(HEIGHT)
        
        a = []
        gen = 0
        for i in range(0, WIDTH):
            b = []
            for j in range(0, HEIGHT):
                b.append(int(dfile.readline()))
            a.append(b)
        dfile.close()
        
########## グライダー ##########

def glider():
    global a
    global gen
    a = []
    gen = 0
    for i in range(0, WIDTH):
        a.append([0] * HEIGHT)
    x0 = WIDTH // 2
    y0 = HEIGHT // 4
    a[x0    ][y0 - 1] = 1
    a[x0 + 1][y0    ] = 1
    a[x0 - 1][y0 + 1] = 1
    a[x0    ][y0 + 1] = 1
    a[x0 + 1][y0 + 1] = 1

########## 2つのグライダー ##########

def two_gliders():
    global a
    global gen
    a = []
    gen = 0
    for i in range(0, WIDTH):
        a.append([0] * HEIGHT)
    x0 = WIDTH // 3
    y0 = HEIGHT // 4
    y1 = (3 * HEIGHT) // 4
    a[x0    ][y0 - 1] = 1
    a[x0 + 1][y0] = 1
    a[x0 - 1][y0 + 1] = 1
    a[x0    ][y0 + 1] = 1
    a[x0 + 1][y0 + 1] = 1
    a[x0 - 1][y1    ] = 1
    a[x0    ][y1 - 1] = 1
    a[x0 + 1][y1 - 1] = 1
    a[x0 + 1][y1    ] = 1
    a[x0 + 1][y1 + 1] = 1

########## 宇宙船 ##########

def spaceship():
    global a
    global gen
    a = []
    gen = 0
    for i in range(0, WIDTH):
        a.append([0] * HEIGHT)
    x0 = WIDTH // 2
    y0 = HEIGHT // 2
    a[x0 - 1][y0 - 2] = 1
    a[x0 + 2][y0 - 2] = 1
    a[x0 - 2][y0 - 1] = 1
    a[x0 - 2][y0    ] = 1
    a[x0 + 2][y0    ] = 1
    a[x0 - 2][y0 + 1] = 1
    a[x0 - 1][y0 + 1] = 1
    a[x0    ][y0 + 1] = 1
    a[x0 + 1][y0 + 1] = 1

########## どんぐり ##########
    
def acorn():
    global a
    global gen
    a = []
    gen = 0
    for i in range(0, WIDTH):
        a.append([0] * HEIGHT)
    x0 = WIDTH // 2
    y0 = HEIGHT // 2
    a[x0 - 3][y0 + 1] = 1
    a[x0 - 2][y0 - 1] = 1
    a[x0 - 2][y0 + 1] = 1
    a[x0    ][y0    ] = 1
    a[x0 + 1][y0 + 1] = 1
    a[x0 + 2][y0 + 1] = 1
    a[x0 + 3][y0 + 1] = 1  

########## ダイ・ハード ##########

def die_hard():
    global a
    global gen
    a = []
    gen = 0
    for i in range(0, WIDTH):
        a.append([0] * HEIGHT)
    x0 = WIDTH // 2
    y0 = HEIGHT // 2
    a[x0 - 3][y0] = 1
    a[x0 - 2][y0] = 1
    a[x0 - 2][y0 + 1] = 1
    a[x0 + 2][y0 + 1] = 1
    a[x0 + 3][y0 - 1] = 1
    a[x0 + 3][y0 + 1] = 1
    a[x0 + 4][y0 + 1] = 1

########## 初期データのコピー ##########

def initial_data_copy():
    global a0
    a0 = []
    for x in a:
        b = []
        for y in x:
            b.append(y)
        a0.append(b)

########## メイン・ルーチン ##########

if __name__ == '__main__':
    f0 = Frame()
    f0.grid()
    # python の version によっては次の行が必要
    f0.mainloop()

