# -*- coding: utf-8 -*-
#
# 情報処理教材おみくじプログラム
# omikuji.py
#
# シャープ記号から行末までは注釈文です。動作には関係ありません。

#---------- ここはおまじない --------------------------------------

from tkinter import Tk, Label, PhotoImage, Button
from random import randint, random, seed, choice

#---------- 吉凶の登録 -------------------------------------------

# 吉凶の種類
ktypes = ['大　吉', '中　吉', '小　吉', '　吉　', '末　吉', '　凶　']
# 吉凶の出現比率（正整数で設定）
kratio  = [3, 2, 2, 3, 2, 2]

#---------- 運勢の登録 -------------------------------------------
# 各項目の文句は書き換えても増やしても構わない。
# ・半角の ' と ' で囲んで、半角の , で区切る。
# ・'' の中以外ではスペース（空白）は半角を使う。
#
# 項目を増やすときは他の項目をまねて書き、 
# 下の koumoku_list に項目名を追加する。　　
#
# 追加項目としてはたとえば、
# 金運、仕事、商売（あきない）、失物（うせもの）、待人（まちびと）、交友、
# 相場、争事（あらそいごと）、縁談、出産（おさん）、転居（やうつり） など
#----------------------------------------------------------------

# 願望（ねがいごと）
negaigoto = [
'願望　大願成就す',
'願望　すぐには叶わぬ　焦らずに待て',
'願望　ふたつこと願うはよからず',
'願望　後に必ず叶う',
'願望　諸事叶う',
'願望　ひとの幸せ願うがよし',
'願望　叶うこと多し',
'願望　願い続ければ叶う',
'願望　叶わぬまでも前進あり'    # 最後の行は , 無し
]

# 学問
gakumon = [
'学問　大いに励め',
'学問　地道がいちばん',
'学問　難題解決す',
'学問　視野を広く持て',
'学問　目標を見定めよ',
'学問　苦手克服す',
'学問　基礎を怠らぬよう',
'学問　安心して努力せよ'  # 最後の行は , 無し
]

# 恋愛
rennai = [
'恋愛　長年の恋叶う',
'恋愛　新たな出会いあり',
'恋愛　わがままは禁物',
'恋愛　ますます想い深まる',
'恋愛　この人より他になし',
'恋愛　真心伝わる',
'恋愛　想い伝わる',
'恋愛　心遣い忘れずに',
'恋愛　焦りは禁物',
'恋愛　波風起こる'     # 最後の行は , 無し
]

# 旅行（たびだち）
tabidachi = [
'旅行　急がぬ方が良い',
'旅行　さわりなし',
'旅行　大いに楽しめ',
'旅行　東西南北いずれもよし',
'旅行　天候への備えが肝要',
'旅行　吉日を選べ',
'旅行　連れを選べ'     # 最後の行は , 無し
]

# 病気（やまい）
yamai = [
'病気　次第に癒える',
'病気　思うより軽し',
'病気　心配いらぬ',
'病気　暴飲暴食は控えよ',
'病気　気遣いなし',
'病気　気晴らしするが宜し',
'病気　医師を選べ',
'病気　気長に養生せよ']

koumoku_list = [negaigoto, gakumon, rennai, tabidachi, yamai]

#---------- 画像登録 ---------------------------------------------
# 画像を貼り替えるときはファイル名を変える。gif は可。jpg は不可

image_name = 'daikokusama.gif'

#----- ここから後ろは触らなくてよい（上級者はもちろん触っても良い）-----

# 吉凶リストの作成
kikkyou = []
for i in range(len(ktypes)):
    for j in range(kratio[i]):
        kikkyou.append(ktypes[i])

# 項目リストへの吉凶リストの追加
koumoku_list = [kikkyou] + koumoku_list
N = len(koumoku_list)

root = Tk()
# ウィンドウタイトル
root.title('電 子 お み く じ')
# 背景色の設定
root.configure(background = 'white')
# 画像の設定とサイズ取得
pict = PhotoImage(file = image_name)
pictx = pict.width()
picty = pict.height()
# ウィンドウの高さの設定
h = 35 * N + 155 + picty
# ウィンドウサイズの設定
root.geometry('400x' + ('%d' % h) + '+200+20')
# 画像の表示
Label(root, image = pict).place(x = 200 - (pictx // 2), y = (h - picty - 20))
# 運勢を書き込むラベルの宣言
L = [Label(foreground = 'black', background = 'white') for i in range(N)] 

# くじ引き関数
def lot(event):
    y0 = 165 # 吉凶以外の運勢の表示位置の y 座標の初期値
    for i in range(N): # 運勢項目
        koumoku = koumoku_list[i]
        fortune = choice(koumoku)
        if i == 0: # 吉凶の表示
            L[i].config(text = fortune, font = ('ＭＳ 明朝', 36))
            L[i].place(x = 105, y = 75)
        else: # 吉凶以外の運勢の表示
            L[i].config(text = fortune, font = ('ＭＳ ゴシック', 12))
            L[i].place(x = 20, y = y0)
            y0 += 35

# ウィンドウ終了の関数
def finish(event):
    root.destroy()

# ボタン１登録
B1 = Button(text = 'おみくじを引く', foreground = 'black', background = '#f0f0f0', font = ('ＭＳ ゴシック', 12))
B1.bind('<Button-1>', lot)
B1.place(x = 3, y = 3, width = 196, height = 40)

# ボタン２登録
B2 = Button(text = '終　了', foreground = 'black', background = '#f0f0f0', font = ('ＭＳ ゴシック', 12))
B2.bind('<Button-1>', finish)
B2.place(x = 201, y = 3, width = 196, height = 40)

# メインルーティン
seed()
root.mainloop()

