#-*- coding: utf-8 -*-
# 1行目は日本語コードの指定
#
# sample3.py
# 上級者用のサンプル（関数定義、制御構造、リストの例）
# 2022.7.27

from sys import *

#----- 関数定義部 -----

# 階乗を計算する関数
# n が 1 以下なら( if n <= 1)、値 1 を返し、
# そうでなければ ( else )、n × (n-1)! を返す
# 制御範囲は Tab による字下げで
def factorial(n):
    if n <= 1:
        return 1        
    else:
        return n * factorial(n - 1)

#----- 以下がメインルーティン（プログラムの本体）-----

# for 文
for n in range(1, 21): # 1 以上 21 未満の n　について繰り返す
    print(n, '! =', factorial(n))
print()

# while 文

n = 1         # n の初期値は 1 とし、
while n < 21: # n が 21 未満の間繰り返す 
    print(n, '! =', factorial(n))
    n = n + 1 # n を 1 増やす
print()

# リスト（他言語の配列に相当） 

a = []                      # 空リストを用意し
for n in range(1, 21):
    a.append(factorial(n))  # 関数値をリストに追加してゆく
print('関数値を格納したリスト :', a)
print()
for n in range(1, 21):
    print(n, '! =', a[n - 1])
    

